import { EventEmitter, ViewContainerRef, Injector, ComponentFactoryResolver, AfterViewInit, Renderer2, ElementRef, NgZone } from '@angular/core';
import { DatePicker } from './DatePicker';
import { IgxSelectedValueChangedEventArgs } from "./igx-selected-value-changed-event-args";
import { IgxGotFocusEventArgs } from "./igx-got-focus-event-args";
import { IgxLostFocusEventArgs } from "./igx-lost-focus-event-args";
import { IgxInputChangeEventArgs } from "./igx-input-change-event-args";
import { IgxKeyEventArgs } from "igniteui-angular-core";
import { ControlDisplayDensity } from "igniteui-angular-core";
import { BaseControlTheme } from "igniteui-angular-core";
import { DateFormats } from "./DateFormats";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
import * as i0 from "@angular/core";
export declare class IgxDatePickerComponent implements AfterViewInit {
    private renderer;
    private _elRef;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    _datePickerContainer: ElementRef;
    private _height;
    private _width;
    private _dataSource;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _wrapper;
    private _root;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    private _implementation;
    ngAfterViewInit(): void;
    protected createImplementation(): DatePicker;
    get i(): DatePicker;
    private _datePicker;
    /**
 * Gets or Sets the property name that contains the values.
*/
    get value(): Date;
    set value(v: Date);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get today(): Date;
    set today(v: Date);
    /**
     * Gets or Sets the property name that contains the label.
    */
    get label(): string;
    set label(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get labelTextColor(): string;
    set labelTextColor(v: string);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get labelTextStyle(): string;
    set labelTextStyle(v: string);
    /**
     * Gets or Sets the property name that contains the placeholder.
    */
    get placeholder(): string;
    set placeholder(v: string);
    /**
     * Gets or Sets the property name that contains the MinDate.
    */
    get minDate(): Date;
    set minDate(v: Date);
    /**
     * Gets or Sets the property name that contains the MaxDate.
    */
    get maxDate(): Date;
    set maxDate(v: Date);
    /**
     * Gets or sets the display density to use for the date pcicker.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    static ngAcceptInputType_density: ControlDisplayDensity | string;
    /**
     * Gets or sets the base built in theme to use for the date picker.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    static ngAcceptInputType_baseTheme: BaseControlTheme | string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or Sets the text color
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or Sets the text color
    */
    get iconColor(): string;
    set iconColor(v: string);
    /**
     * Gets or sets the ShowClearButton property to detirmine if the clear button is shown
    */
    get showClearButton(): boolean;
    set showClearButton(v: boolean);
    static ngAcceptInputType_showClearButton: boolean | string;
    /**
     * Gets or sets the ShowTodayButton property to detirmine if the today button is shown
    */
    get showTodayButton(): boolean;
    set showTodayButton(v: boolean);
    static ngAcceptInputType_showTodayButton: boolean | string;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    get allowTextInput(): boolean;
    set allowTextInput(v: boolean);
    static ngAcceptInputType_allowTextInput: boolean | string;
    /**
     * Gets or sets the AllowTextInput property to detirmine if entering text into the input is allowed
    */
    get openOnFocus(): boolean;
    set openOnFocus(v: boolean);
    static ngAcceptInputType_openOnFocus: boolean | string;
    /**
     * Gets or sets the FirstDayOfWeek property to detirmine first day of the week
    */
    get firstDayOfWeek(): DayOfWeek;
    set firstDayOfWeek(v: DayOfWeek);
    static ngAcceptInputType_firstDayOfWeek: DayOfWeek | string;
    /**
     * Gets or sets the FirstWeekOfYear property to detirmine first week of the year
    */
    get firstWeekOfYear(): FirstWeek;
    set firstWeekOfYear(v: FirstWeek);
    static ngAcceptInputType_firstWeekOfYear: FirstWeek | string;
    /**
     * Gets or sets the ShowWeekNumbers property to detirmine if the week numbers are shown
    */
    get showWeekNumbers(): boolean;
    set showWeekNumbers(v: boolean);
    static ngAcceptInputType_showWeekNumbers: boolean | string;
    /**
     * Gets or sets the date time format to use for this column. If FormatString is specificied this value is ignored.
    */
    get dateFormat(): DateFormats;
    set dateFormat(v: DateFormats);
    static ngAcceptInputType_dateFormat: DateFormats | string;
    /**
     * Gets or sets the Format property to detirmine the format of the date in the input
    */
    get formatString(): string;
    set formatString(v: string);
    get isDisabled(): boolean;
    set isDisabled(v: boolean);
    static ngAcceptInputType_isDisabled: boolean | string;
    /**
     * Indicates that the calendar dropdown will position itself relative to the window instead of the document.
    */
    get isFixed(): boolean;
    set isFixed(v: boolean);
    static ngAcceptInputType_isFixed: boolean | string;
    /**
     * Indicates that the dropdown should open as a child of the date picker.
    */
    get openAsChild(): boolean;
    set openAsChild(v: boolean);
    static ngAcceptInputType_openAsChild: boolean | string;
    /**
     * Indicates that the dropdown will place itself into the browser top layer.
    */
    get useTopLayer(): boolean;
    set useTopLayer(v: boolean);
    static ngAcceptInputType_useTopLayer: boolean | string;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    select(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _selectedValueChanged;
    /**
     * Called when date is selected.
    */
    get selectedValueChanged(): EventEmitter<{
        sender: any;
        args: IgxSelectedValueChangedEventArgs;
    }>;
    private _gotFocus;
    get gotFocus(): EventEmitter<{
        sender: any;
        args: IgxGotFocusEventArgs;
    }>;
    private _lostFocus;
    get lostFocus(): EventEmitter<{
        sender: any;
        args: IgxLostFocusEventArgs;
    }>;
    private _keyDown;
    get keyDown(): EventEmitter<{
        sender: any;
        args: IgxKeyEventArgs;
    }>;
    private _changing;
    get changing(): EventEmitter<{
        sender: any;
        args: IgxInputChangeEventArgs;
    }>;
    private _valueChange;
    get valueChange(): EventEmitter<Date>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxDatePickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxDatePickerComponent, "igx-date-picker", never, { "height": "height"; "width": "width"; "value": "value"; "today": "today"; "label": "label"; "labelTextColor": "labelTextColor"; "labelTextStyle": "labelTextStyle"; "placeholder": "placeholder"; "minDate": "minDate"; "maxDate": "maxDate"; "density": "density"; "baseTheme": "baseTheme"; "textStyle": "textStyle"; "textColor": "textColor"; "iconColor": "iconColor"; "showClearButton": "showClearButton"; "showTodayButton": "showTodayButton"; "allowTextInput": "allowTextInput"; "openOnFocus": "openOnFocus"; "firstDayOfWeek": "firstDayOfWeek"; "firstWeekOfYear": "firstWeekOfYear"; "showWeekNumbers": "showWeekNumbers"; "dateFormat": "dateFormat"; "formatString": "formatString"; "isDisabled": "isDisabled"; "isFixed": "isFixed"; "openAsChild": "openAsChild"; "useTopLayer": "useTopLayer"; }, { "selectedValueChanged": "selectedValueChanged"; "gotFocus": "gotFocus"; "lostFocus": "lostFocus"; "keyDown": "keyDown"; "changing": "changing"; "valueChange": "valueChange"; }, never, never>;
}
