import { TemplateRef, EventEmitter, ViewContainerRef, Injector, ComponentFactoryResolver, AfterViewInit, Renderer2, NgZone } from '@angular/core';
import { XButton } from "./XButton";
import { ButtonDisplayStyle } from './ButtonDisplayStyle';
import { IgxButtonClickEventArgs } from './igx-button-click-event-args';
import { ControlDisplayDensity } from "igniteui-angular-core";
import { ElevationMode } from "igniteui-angular-core";
import { BaseControlTheme } from "igniteui-angular-core";
import { HorizontalAlignment } from "igniteui-angular-core";
import { VerticalAlignment } from "igniteui-angular-core";
import { IgxFocusEventArgs } from "igniteui-angular-core";
import * as i0 from "@angular/core";
export declare class IgxXButtonComponent implements AfterViewInit {
    private renderer;
    private _elRef;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    private _wrapper;
    private _portalManager;
    private _root;
    _dynamicContent: ViewContainerRef;
    _childTemplateRef: TemplateRef<any>;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    protected createImplementation(): XButton;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): XButton; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgxXButtonComponent;
    private _button;
    /**
 * Gets or sets the min width to use for the button.
*/
    get minWidth(): number;
    set minWidth(v: number);
    static ngAcceptInputType_minWidth: number | string;
    /**
     * Gets or sets the min height to use for the button.
    */
    get minHeight(): number;
    set minHeight(v: number);
    static ngAcceptInputType_minHeight: number | string;
    /**
     * Gets or sets the display style to use for the button.
    */
    get displayType(): ButtonDisplayStyle;
    set displayType(v: ButtonDisplayStyle);
    static ngAcceptInputType_displayType: ButtonDisplayStyle | string;
    /**
     * Gets or sets the display density to use for the button.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    static ngAcceptInputType_density: ControlDisplayDensity | string;
    /**
     * Gets or sets the base built in theme to use for the button.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    static ngAcceptInputType_baseTheme: BaseControlTheme | string;
    /**
     * Gets the actual display density to use for the label.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    static ngAcceptInputType_actualDensity: ControlDisplayDensity | string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualBorderColor(): string;
    set actualBorderColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualUmbraShadowColor(): string;
    set actualUmbraShadowColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualPenumbraShadowColor(): string;
    set actualPenumbraShadowColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualAmbientShadowColor(): string;
    set actualAmbientShadowColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualRestingElevation(): number;
    set actualRestingElevation(v: number);
    static ngAcceptInputType_actualRestingElevation: number | string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualFocusElevation(): number;
    set actualFocusElevation(v: number);
    static ngAcceptInputType_actualFocusElevation: number | string;
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualHoverElevation(): number;
    set actualHoverElevation(v: number);
    static ngAcceptInputType_actualHoverElevation: number | string;
    /**
     * Gets or sets the color to use for the ripple when the button is pressed.
    */
    get actualRippleColor(): string;
    set actualRippleColor(v: string);
    get actualCornerRadiusBottomRight(): number;
    set actualCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_actualCornerRadiusBottomRight: number | string;
    get actualCornerRadiusBottomLeft(): number;
    set actualCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_actualCornerRadiusBottomLeft: number | string;
    get actualCornerRadiusTopLeft(): number;
    set actualCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_actualCornerRadiusTopLeft: number | string;
    get actualCornerRadiusTopRight(): number;
    set actualCornerRadiusTopRight(v: number);
    static ngAcceptInputType_actualCornerRadiusTopRight: number | string;
    ensureActualCornerRadius(): void;
    /**
     * Gets the color to use for the actual background.
    */
    get actualBackgroundColor(): string;
    set actualBackgroundColor(v: string);
    /**
     * Gets the actual color to use for the disabled background of the button.
    */
    get actualDisabledBackgroundColor(): string;
    set actualDisabledBackgroundColor(v: string);
    /**
     * Gets the actual color to use for the disabled border of the button.
    */
    get actualDisabledBorderColor(): string;
    set actualDisabledBorderColor(v: string);
    /**
     * Gets the actual color to use for the disabled text of the button.
    */
    get actualDisabledTextColor(): string;
    set actualDisabledTextColor(v: string);
    /**
     * Gets the actual disabled elevation to use for the button.
    */
    get actualDisabledElevation(): number;
    set actualDisabledElevation(v: number);
    static ngAcceptInputType_actualDisabledElevation: number | string;
    /**
     * Gets the actual disabled elevation to use for the button.
    */
    get actualElevationMode(): ElevationMode;
    set actualElevationMode(v: ElevationMode);
    static ngAcceptInputType_actualElevationMode: ElevationMode | string;
    /**
     * Gets the color to use for the actual background.
    */
    get actualTextColor(): string;
    set actualTextColor(v: string);
    /**
     * Gets the color to use for the actual background.
    */
    get actualHoverTextColor(): string;
    set actualHoverTextColor(v: string);
    /**
     * Gets the color to use for the actual background.
    */
    get actualFocusBackgroundColor(): string;
    set actualFocusBackgroundColor(v: string);
    /**
     * Gets the actual color to use for the focused text.
    */
    get actualFocusTextColor(): string;
    set actualFocusTextColor(v: string);
    /**
     * Gets the hover color to use for the actual background.
    */
    get actualHoverBackgroundColor(): string;
    set actualHoverBackgroundColor(v: string);
    /**
     * Gets or sets the Width to use for the check mark when the checkbox is checked.
    */
    get actualBorderWidth(): number;
    set actualBorderWidth(v: number);
    static ngAcceptInputType_actualBorderWidth: number | string;
    /**
     * Gets or sets the color to use for the background of the button when the  type is raised.
    */
    get raisedBackgroundColor(): string;
    set raisedBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled background of the button when the type is raised.
    */
    get raisedDisabledBackgroundColor(): string;
    set raisedDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled border of the button when the type is raised.
    */
    get raisedDisabledBorderColor(): string;
    set raisedDisabledBorderColor(v: string);
    /**
     * Gets or sets the color to use for the disabled text of the button when the type is raised.
    */
    get raisedDisabledTextColor(): string;
    set raisedDisabledTextColor(v: string);
    /**
     * Gets or sets the disabled elevation to use for the button when the type is raised.
    */
    get raisedDisabledElevation(): number;
    set raisedDisabledElevation(v: number);
    static ngAcceptInputType_raisedDisabledElevation: number | string;
    /**
     * Gets or sets the hover color to use for the background of the button when the  type is raised.
    */
    get raisedHoverBackgroundColor(): string;
    set raisedHoverBackgroundColor(v: string);
    /**
     * Gets or sets the border color to use for the button when the type is raised.
    */
    get raisedBorderColor(): string;
    set raisedBorderColor(v: string);
    /**
     * Gets or sets the elevation to use for the button when the type is raised.
    */
    get raisedRestingElevation(): number;
    set raisedRestingElevation(v: number);
    static ngAcceptInputType_raisedRestingElevation: number | string;
    /**
     * Gets or sets the hover elevation to use for the button when the type is raised.
    */
    get raisedHoverElevation(): number;
    set raisedHoverElevation(v: number);
    static ngAcceptInputType_raisedHoverElevation: number | string;
    /**
     * Gets or sets the focus elevation to use for the button when the type is raised.
    */
    get raisedFocusElevation(): number;
    set raisedFocusElevation(v: number);
    static ngAcceptInputType_raisedFocusElevation: number | string;
    /**
     * Gets or sets the width to use for the button border when the type is raised.
    */
    get raisedBorderWidth(): number;
    set raisedBorderWidth(v: number);
    static ngAcceptInputType_raisedBorderWidth: number | string;
    get raisedCornerRadiusBottomRight(): number;
    set raisedCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_raisedCornerRadiusBottomRight: number | string;
    get raisedCornerRadiusBottomLeft(): number;
    set raisedCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_raisedCornerRadiusBottomLeft: number | string;
    get raisedCornerRadiusTopLeft(): number;
    set raisedCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_raisedCornerRadiusTopLeft: number | string;
    get raisedCornerRadiusTopRight(): number;
    set raisedCornerRadiusTopRight(v: number);
    static ngAcceptInputType_raisedCornerRadiusTopRight: number | string;
    ensureRaisedCornerRadius(): void;
    /**
     * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
    */
    get raisedRippleColor(): string;
    set raisedRippleColor(v: string);
    /**
     * Gets or sets the color to use for the background of the button when the type is flat.
    */
    get flatBackgroundColor(): string;
    set flatBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled background of the button when the type is flat.
    */
    get flatDisabledBackgroundColor(): string;
    set flatDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled border of the button when the type is flat.
    */
    get flatDisabledBorderColor(): string;
    set flatDisabledBorderColor(v: string);
    /**
     * Gets or sets the color to use for the disabled text of the button when the type is flat.
    */
    get flatDisabledTextColor(): string;
    set flatDisabledTextColor(v: string);
    /**
     * Gets or sets the disabled elevation to use for the button when the type is flat.
    */
    get flatDisabledElevation(): number;
    set flatDisabledElevation(v: number);
    static ngAcceptInputType_flatDisabledElevation: number | string;
    /**
     * Gets or sets the hover color to use for the background of the button when the type is flat.
    */
    get flatHoverBackgroundColor(): string;
    set flatHoverBackgroundColor(v: string);
    /**
     * Gets or sets the border color to use for the button when the type is flat.
    */
    get flatBorderColor(): string;
    set flatBorderColor(v: string);
    /**
     * Gets or sets the elevation to use for the button when the type is flat.
    */
    get flatRestingElevation(): number;
    set flatRestingElevation(v: number);
    static ngAcceptInputType_flatRestingElevation: number | string;
    /**
     * Gets or sets the hover elevation to use for the button when the type is flat.
    */
    get flatHoverElevation(): number;
    set flatHoverElevation(v: number);
    static ngAcceptInputType_flatHoverElevation: number | string;
    /**
     * Gets or sets the focus elevation to use for the button when the type is flat.
    */
    get flatFocusElevation(): number;
    set flatFocusElevation(v: number);
    static ngAcceptInputType_flatFocusElevation: number | string;
    /**
     * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
    */
    get flatRippleColor(): string;
    set flatRippleColor(v: string);
    /**
     * Gets or sets the color to use for the text of the button when type is flat.
    */
    get flatTextColor(): string;
    set flatTextColor(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button when type is flat.
    */
    get flatHoverTextColor(): string;
    set flatHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the backround the button when it is focused and flat.
    */
    get flatFocusBackgroundColor(): string;
    set flatFocusBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text the button when it is focused and flat.
    */
    get flatFocusTextColor(): string;
    set flatFocusTextColor(v: string);
    /**
     * Gets or sets the width to use for the button border when the type is flat.
    */
    get flatBorderWidth(): number;
    set flatBorderWidth(v: number);
    static ngAcceptInputType_flatBorderWidth: number | string;
    get flatCornerRadiusBottomRight(): number;
    set flatCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_flatCornerRadiusBottomRight: number | string;
    get flatCornerRadiusBottomLeft(): number;
    set flatCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_flatCornerRadiusBottomLeft: number | string;
    get flatCornerRadiusTopLeft(): number;
    set flatCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_flatCornerRadiusTopLeft: number | string;
    get flatCornerRadiusTopRight(): number;
    set flatCornerRadiusTopRight(v: number);
    static ngAcceptInputType_flatCornerRadiusTopRight: number | string;
    ensureFlatCornerRadius(): void;
    /**
     * Gets or sets the color to use for the background when the button regardless of type.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled background of the button when the type is disabled.
    */
    get disabledBackgroundColor(): string;
    set disabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled border of the button when the type is raised.
    */
    get disabledBorderColor(): string;
    set disabledBorderColor(v: string);
    /**
     * Gets or sets the color to use for the disabled text of the button when the type is raised.
    */
    get disabledTextColor(): string;
    set disabledTextColor(v: string);
    /**
     * Gets or sets the disabled elevation to use for the button when the type is raised.
    */
    get disabledElevation(): number;
    set disabledElevation(v: number);
    static ngAcceptInputType_disabledElevation: number | string;
    /**
     * Gets or sets the disabled elevation to use for the button when the type is raised.
    */
    get elevationMode(): ElevationMode;
    set elevationMode(v: ElevationMode);
    static ngAcceptInputType_elevationMode: ElevationMode | string;
    /**
     * Gets or sets the hover color to use for the background of the button when the  type is hovered.
    */
    get hoverBackgroundColor(): string;
    set hoverBackgroundColor(v: string);
    /**
     * Gets or sets the border color to use for the button regardless of type.
    */
    get borderColor(): string;
    set borderColor(v: string);
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    get restingElevation(): number;
    set restingElevation(v: number);
    static ngAcceptInputType_restingElevation: number | string;
    /**
     * Gets or sets the hover elevation to use for the button regardless of type.
    */
    get hoverElevation(): number;
    set hoverElevation(v: number);
    static ngAcceptInputType_hoverElevation: number | string;
    /**
     * Gets or sets the focus elevation to use for the button regardless of type.
    */
    get focusElevation(): number;
    set focusElevation(v: number);
    static ngAcceptInputType_focusElevation: number | string;
    /**
     * Gets or sets the use for the button.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the color to use for the text of the button regardless of type.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button regardless of type.
    */
    get hoverTextColor(): string;
    set hoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the background of the button regardless of type.
    */
    get rippleColor(): string;
    set rippleColor(v: string);
    /**
     * Gets or sets the color to use for the text of the button when type is raised.
    */
    get raisedTextColor(): string;
    set raisedTextColor(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button when type is raised.
    */
    get raisedHoverTextColor(): string;
    set raisedHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the backround the button when it is focused and raised.
    */
    get raisedFocusBackgroundColor(): string;
    set raisedFocusBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text the button when it is focused and raised.
    */
    get raisedFocusTextColor(): string;
    set raisedFocusTextColor(v: string);
    /**
     * Gets or sets the color to use for the backround the button when it is focused.
    */
    get focusBackgroundColor(): string;
    set focusBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text of the button when it is focused.
    */
    get focusTextColor(): string;
    set focusTextColor(v: string);
    /**
     * Gets or sets the width to use for the button border regardless of type.
    */
    get borderWidth(): number;
    set borderWidth(v: number);
    static ngAcceptInputType_borderWidth: number | string;
    get cornerRadiusBottomRight(): number;
    set cornerRadiusBottomRight(v: number);
    static ngAcceptInputType_cornerRadiusBottomRight: number | string;
    get cornerRadiusBottomLeft(): number;
    set cornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_cornerRadiusBottomLeft: number | string;
    get cornerRadiusTopLeft(): number;
    set cornerRadiusTopLeft(v: number);
    static ngAcceptInputType_cornerRadiusTopLeft: number | string;
    get cornerRadiusTopRight(): number;
    set cornerRadiusTopRight(v: number);
    static ngAcceptInputType_cornerRadiusTopRight: number | string;
    ensureCornerRadius(): void;
    /**
     * Gets or sets the color to use for the background of the button when the  type is outlined.
    */
    get outlinedBackgroundColor(): string;
    set outlinedBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled background of the button when the type is outlined.
    */
    get outlinedDisabledBackgroundColor(): string;
    set outlinedDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled border of the button when the type is outlined.
    */
    get outlinedDisabledBorderColor(): string;
    set outlinedDisabledBorderColor(v: string);
    /**
     * Gets or sets the color to use for the disabled text of the button when the type is outlined.
    */
    get outlinedDisabledTextColor(): string;
    set outlinedDisabledTextColor(v: string);
    /**
     * Gets or sets the disabled elevation to use for the button when the type is outlined.
    */
    get outlinedDisabledElevation(): number;
    set outlinedDisabledElevation(v: number);
    static ngAcceptInputType_outlinedDisabledElevation: number | string;
    /**
     * Gets or sets the hover color to use for the background of the button when the  type is hoveredOutlined.
    */
    get outlinedHoverBackgroundColor(): string;
    set outlinedHoverBackgroundColor(v: string);
    /**
     * Gets or sets the border color to use for the button when the type is outlined.
    */
    get outlinedBorderColor(): string;
    set outlinedBorderColor(v: string);
    /**
     * Gets or sets the elevation to use for the button when the type is outlined.
    */
    get outlinedRestingElevation(): number;
    set outlinedRestingElevation(v: number);
    static ngAcceptInputType_outlinedRestingElevation: number | string;
    /**
     * Gets or sets the hover elevation to use for the button when the type is outlined.
    */
    get outlinedHoverElevation(): number;
    set outlinedHoverElevation(v: number);
    static ngAcceptInputType_outlinedHoverElevation: number | string;
    /**
     * Gets or sets the focus elevation to use for the button when the type is outlined.
    */
    get outlinedFocusElevation(): number;
    set outlinedFocusElevation(v: number);
    static ngAcceptInputType_outlinedFocusElevation: number | string;
    /**
     * Gets or sets the width to use for the button border when the type is outlined.
    */
    get outlinedBorderWidth(): number;
    set outlinedBorderWidth(v: number);
    static ngAcceptInputType_outlinedBorderWidth: number | string;
    get outlinedCornerRadiusBottomRight(): number;
    set outlinedCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_outlinedCornerRadiusBottomRight: number | string;
    get outlinedCornerRadiusBottomLeft(): number;
    set outlinedCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_outlinedCornerRadiusBottomLeft: number | string;
    get outlinedCornerRadiusTopLeft(): number;
    set outlinedCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_outlinedCornerRadiusTopLeft: number | string;
    get outlinedCornerRadiusTopRight(): number;
    set outlinedCornerRadiusTopRight(v: number);
    static ngAcceptInputType_outlinedCornerRadiusTopRight: number | string;
    ensureOutlinedCornerRadius(): void;
    /**
     * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
    */
    get outlinedRippleColor(): string;
    set outlinedRippleColor(v: string);
    /**
     * Gets or sets the color to use for the text of the button when type is outlined.
    */
    get outlinedTextColor(): string;
    set outlinedTextColor(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button when type is outlined.
    */
    get outlinedHoverTextColor(): string;
    set outlinedHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the backround the button when it is focused and outlined.
    */
    get outlinedFocusBackgroundColor(): string;
    set outlinedFocusBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text the button when it is focused and outlined.
    */
    get outlinedFocusTextColor(): string;
    set outlinedFocusTextColor(v: string);
    /**
     * Gets or sets the color to use for the background of the button when the  type is floating action button.
    */
    get fabBackgroundColor(): string;
    set fabBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled background of the button when the type is fab.
    */
    get fabDisabledBackgroundColor(): string;
    set fabDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled border of the button when the type is fab.
    */
    get fabDisabledBorderColor(): string;
    set fabDisabledBorderColor(v: string);
    /**
     * Gets or sets the color to use for the disabled text of the button when the type is fab.
    */
    get fabDisabledTextColor(): string;
    set fabDisabledTextColor(v: string);
    /**
     * Gets or sets the disabled elevation to use for the button when the type is fab.
    */
    get fabDisabledElevation(): number;
    set fabDisabledElevation(v: number);
    static ngAcceptInputType_fabDisabledElevation: number | string;
    /**
     * Gets or sets the hover color to use for the background of the button when the  type is hoveredFab.
    */
    get fabHoverBackgroundColor(): string;
    set fabHoverBackgroundColor(v: string);
    /**
     * Gets or sets the border color to use for the button when the type is floating action button.
    */
    get fabBorderColor(): string;
    set fabBorderColor(v: string);
    /**
     * Gets or sets the elevation to use for the button when the type is floating action button.
    */
    get fabRestingElevation(): number;
    set fabRestingElevation(v: number);
    static ngAcceptInputType_fabRestingElevation: number | string;
    /**
     * Gets or sets the hover elevation to use for the button when the type is floating action button.
    */
    get fabHoverElevation(): number;
    set fabHoverElevation(v: number);
    static ngAcceptInputType_fabHoverElevation: number | string;
    /**
     * Gets or sets the focus elevation to use for the button when the type is floating action button.
    */
    get fabFocusElevation(): number;
    set fabFocusElevation(v: number);
    static ngAcceptInputType_fabFocusElevation: number | string;
    /**
     * Gets or sets the width to use for the button border when the type is floating action button.
    */
    get fabBorderWidth(): number;
    set fabBorderWidth(v: number);
    static ngAcceptInputType_fabBorderWidth: number | string;
    get fabCornerRadiusBottomRight(): number;
    set fabCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_fabCornerRadiusBottomRight: number | string;
    get fabCornerRadiusBottomLeft(): number;
    set fabCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_fabCornerRadiusBottomLeft: number | string;
    get fabCornerRadiusTopLeft(): number;
    set fabCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_fabCornerRadiusTopLeft: number | string;
    get fabCornerRadiusTopRight(): number;
    set fabCornerRadiusTopRight(v: number);
    static ngAcceptInputType_fabCornerRadiusTopRight: number | string;
    ensureFabCornerRadius(): void;
    /**
     * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
    */
    get fabRippleColor(): string;
    set fabRippleColor(v: string);
    /**
     * Gets or sets the color to use for the text of the button when type is floating action button.
    */
    get fabTextColor(): string;
    set fabTextColor(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button when type is floating action button.
    */
    get fabHoverTextColor(): string;
    set fabHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the backround the button when it is focused and fab.
    */
    get fabFocusBackgroundColor(): string;
    set fabFocusBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text the button when it is focused and fab.
    */
    get fabFocusTextColor(): string;
    set fabFocusTextColor(v: string);
    /**
     * Gets or sets the color to use for the background of the button when the  type is icon.
    */
    get iconBackgroundColor(): string;
    set iconBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled background of the button when the type is icon.
    */
    get iconDisabledBackgroundColor(): string;
    set iconDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the disabled border of the button when the type is icon.
    */
    get iconDisabledBorderColor(): string;
    set iconDisabledBorderColor(v: string);
    /**
     * Gets or sets the color to use for the disabled text of the button when the type is icon.
    */
    get iconDisabledTextColor(): string;
    set iconDisabledTextColor(v: string);
    /**
     * Gets or sets the disabled elevation to use for the button when the type is icon.
    */
    get iconDisabledElevation(): number;
    set iconDisabledElevation(v: number);
    static ngAcceptInputType_iconDisabledElevation: number | string;
    /**
     * Gets or sets the hover color to use for the background of the button when the  type is hoveredIcon.
    */
    get iconHoverBackgroundColor(): string;
    set iconHoverBackgroundColor(v: string);
    /**
     * Gets or sets the border color to use for the button when the type is icon.
    */
    get iconBorderColor(): string;
    set iconBorderColor(v: string);
    /**
     * Gets or sets the elevation to use for the button when the type is icon.
    */
    get iconRestingElevation(): number;
    set iconRestingElevation(v: number);
    static ngAcceptInputType_iconRestingElevation: number | string;
    /**
     * Gets or sets the hover elevation to use for the button when the type is icon.
    */
    get iconHoverElevation(): number;
    set iconHoverElevation(v: number);
    static ngAcceptInputType_iconHoverElevation: number | string;
    /**
     * Gets or sets the focus elevation to use for the button when the type is icon.
    */
    get iconFocusElevation(): number;
    set iconFocusElevation(v: number);
    static ngAcceptInputType_iconFocusElevation: number | string;
    /**
     * Gets or sets the width to use for the button border when the type is icon.
    */
    get iconBorderWidth(): number;
    set iconBorderWidth(v: number);
    static ngAcceptInputType_iconBorderWidth: number | string;
    get iconCornerRadiusBottomRight(): number;
    set iconCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_iconCornerRadiusBottomRight: number | string;
    get iconCornerRadiusBottomLeft(): number;
    set iconCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_iconCornerRadiusBottomLeft: number | string;
    get iconCornerRadiusTopLeft(): number;
    set iconCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_iconCornerRadiusTopLeft: number | string;
    get iconCornerRadiusTopRight(): number;
    set iconCornerRadiusTopRight(v: number);
    static ngAcceptInputType_iconCornerRadiusTopRight: number | string;
    ensureIconCornerRadius(): void;
    /**
     * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
    */
    get iconRippleColor(): string;
    set iconRippleColor(v: string);
    /**
     * Gets or sets the color to use for the text of the button when type is icon.
    */
    get iconTextColor(): string;
    set iconTextColor(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button when type is icon.
    */
    get iconHoverTextColor(): string;
    set iconHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the backround the button when it is focused and icon.
    */
    get iconFocusBackgroundColor(): string;
    set iconFocusBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the text the button when it is focused and icon.
    */
    get iconFocusTextColor(): string;
    set iconFocusTextColor(v: string);
    /**
     * Gets or sets the id to use for the internal native checkbox.
    */
    get inputId(): string;
    set inputId(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get display(): string;
    set display(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get flexDirection(): string;
    set flexDirection(v: string);
    /**
     * Gets or sets the flex-grow setting for the button.
    */
    get flexGrow(): string;
    set flexGrow(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get alignItems(): string;
    set alignItems(v: string);
    /**
     * Gets or sets value to use for the checkbox.
    */
    get value(): any;
    set value(v: any);
    /**
     * Gets or sets name to use for the button.
    */
    get name(): string;
    set name(v: string);
    /**
     * Gets or sets TabIndex to use for the checkbox.
    */
    get tabIndex(): number;
    set tabIndex(v: number);
    static ngAcceptInputType_tabIndex: number | string;
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    get ariaLabel(): string;
    set ariaLabel(v: string);
    /**
     * Gets or sets whether the button should fill the available space. If false, the button
     * will use an intrinsic size.
    */
    get fillAvailableSpace(): boolean;
    set fillAvailableSpace(v: boolean);
    static ngAcceptInputType_fillAvailableSpace: boolean | string;
    /**
     * Gets or sets if the checkbox is Focused.
    */
    get focused(): boolean;
    set focused(v: boolean);
    static ngAcceptInputType_focused: boolean | string;
    /**
     * Gets or sets if the button show use styling to show focus.
    */
    get isFocusStyleEnabled(): boolean;
    set isFocusStyleEnabled(v: boolean);
    static ngAcceptInputType_isFocusStyleEnabled: boolean | string;
    /**
     * Gets or sets whether to disable the ripple effect for the button.
    */
    get disableRipple(): boolean;
    set disableRipple(v: boolean);
    static ngAcceptInputType_disableRipple: boolean | string;
    /**
     * Gets whether to actually disable the ripple effect for the button.
    */
    get actualDisableRipple(): boolean;
    set actualDisableRipple(v: boolean);
    static ngAcceptInputType_actualDisableRipple: boolean | string;
    /**
     * Gets or sets whether the hover effect is disabled.
    */
    get disableHover(): boolean;
    set disableHover(v: boolean);
    static ngAcceptInputType_disableHover: boolean | string;
    /**
     * Gets or sets whether the checkbox is checked.
    */
    get isHover(): boolean;
    set isHover(v: boolean);
    static ngAcceptInputType_isHover: boolean | string;
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    static ngAcceptInputType_disabled: boolean | string;
    /**
     * Gets or sets whether the checkbox transitions are disabled.
    */
    get disableTransitions(): boolean;
    set disableTransitions(v: boolean);
    static ngAcceptInputType_disableTransitions: boolean | string;
    /**
     * Gets or sets whether the cursor will change into a pointer when the button is hovered.
    */
    get disablePointer(): boolean;
    set disablePointer(v: boolean);
    static ngAcceptInputType_disablePointer: boolean | string;
    /**
     * Gets or sets the left padding for the button content.
    */
    get contentPaddingLeft(): number;
    set contentPaddingLeft(v: number);
    static ngAcceptInputType_contentPaddingLeft: number | string;
    /**
     * Gets or sets the top padding for the button content.
    */
    get contentPaddingTop(): number;
    set contentPaddingTop(v: number);
    static ngAcceptInputType_contentPaddingTop: number | string;
    /**
     * Gets or sets the right padding for the button content.
    */
    get contentPaddingRight(): number;
    set contentPaddingRight(v: number);
    static ngAcceptInputType_contentPaddingRight: number | string;
    /**
     * Gets or sets the bottom padding for the button content.
    */
    get contentPaddingBottom(): number;
    set contentPaddingBottom(v: number);
    static ngAcceptInputType_contentPaddingBottom: number | string;
    get horizontalContentAlignment(): HorizontalAlignment;
    set horizontalContentAlignment(v: HorizontalAlignment);
    static ngAcceptInputType_horizontalContentAlignment: HorizontalAlignment | string;
    get verticalContentAlignment(): VerticalAlignment;
    set verticalContentAlignment(v: VerticalAlignment);
    static ngAcceptInputType_verticalContentAlignment: VerticalAlignment | string;
    /**
     * Gets or sets if clicking on the button is allowed to tunnel down to button content.
    */
    get clickTunneling(): boolean;
    set clickTunneling(v: boolean);
    static ngAcceptInputType_clickTunneling: boolean | string;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _clicked;
    get clicked(): EventEmitter<{
        sender: any;
        args: IgxButtonClickEventArgs;
    }>;
    private _gotFocus;
    get gotFocus(): EventEmitter<{
        sender: any;
        args: IgxFocusEventArgs;
    }>;
    private _lostFocus;
    get lostFocus(): EventEmitter<{
        sender: any;
        args: IgxFocusEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxXButtonComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxXButtonComponent, "igx-x-button", never, { "minWidth": "minWidth"; "minHeight": "minHeight"; "displayType": "displayType"; "density": "density"; "baseTheme": "baseTheme"; "actualDensity": "actualDensity"; "actualBorderColor": "actualBorderColor"; "actualUmbraShadowColor": "actualUmbraShadowColor"; "actualPenumbraShadowColor": "actualPenumbraShadowColor"; "actualAmbientShadowColor": "actualAmbientShadowColor"; "actualRestingElevation": "actualRestingElevation"; "actualFocusElevation": "actualFocusElevation"; "actualHoverElevation": "actualHoverElevation"; "actualRippleColor": "actualRippleColor"; "actualCornerRadiusBottomRight": "actualCornerRadiusBottomRight"; "actualCornerRadiusBottomLeft": "actualCornerRadiusBottomLeft"; "actualCornerRadiusTopLeft": "actualCornerRadiusTopLeft"; "actualCornerRadiusTopRight": "actualCornerRadiusTopRight"; "actualBackgroundColor": "actualBackgroundColor"; "actualDisabledBackgroundColor": "actualDisabledBackgroundColor"; "actualDisabledBorderColor": "actualDisabledBorderColor"; "actualDisabledTextColor": "actualDisabledTextColor"; "actualDisabledElevation": "actualDisabledElevation"; "actualElevationMode": "actualElevationMode"; "actualTextColor": "actualTextColor"; "actualHoverTextColor": "actualHoverTextColor"; "actualFocusBackgroundColor": "actualFocusBackgroundColor"; "actualFocusTextColor": "actualFocusTextColor"; "actualHoverBackgroundColor": "actualHoverBackgroundColor"; "actualBorderWidth": "actualBorderWidth"; "raisedBackgroundColor": "raisedBackgroundColor"; "raisedDisabledBackgroundColor": "raisedDisabledBackgroundColor"; "raisedDisabledBorderColor": "raisedDisabledBorderColor"; "raisedDisabledTextColor": "raisedDisabledTextColor"; "raisedDisabledElevation": "raisedDisabledElevation"; "raisedHoverBackgroundColor": "raisedHoverBackgroundColor"; "raisedBorderColor": "raisedBorderColor"; "raisedRestingElevation": "raisedRestingElevation"; "raisedHoverElevation": "raisedHoverElevation"; "raisedFocusElevation": "raisedFocusElevation"; "raisedBorderWidth": "raisedBorderWidth"; "raisedCornerRadiusBottomRight": "raisedCornerRadiusBottomRight"; "raisedCornerRadiusBottomLeft": "raisedCornerRadiusBottomLeft"; "raisedCornerRadiusTopLeft": "raisedCornerRadiusTopLeft"; "raisedCornerRadiusTopRight": "raisedCornerRadiusTopRight"; "raisedRippleColor": "raisedRippleColor"; "flatBackgroundColor": "flatBackgroundColor"; "flatDisabledBackgroundColor": "flatDisabledBackgroundColor"; "flatDisabledBorderColor": "flatDisabledBorderColor"; "flatDisabledTextColor": "flatDisabledTextColor"; "flatDisabledElevation": "flatDisabledElevation"; "flatHoverBackgroundColor": "flatHoverBackgroundColor"; "flatBorderColor": "flatBorderColor"; "flatRestingElevation": "flatRestingElevation"; "flatHoverElevation": "flatHoverElevation"; "flatFocusElevation": "flatFocusElevation"; "flatRippleColor": "flatRippleColor"; "flatTextColor": "flatTextColor"; "flatHoverTextColor": "flatHoverTextColor"; "flatFocusBackgroundColor": "flatFocusBackgroundColor"; "flatFocusTextColor": "flatFocusTextColor"; "flatBorderWidth": "flatBorderWidth"; "flatCornerRadiusBottomRight": "flatCornerRadiusBottomRight"; "flatCornerRadiusBottomLeft": "flatCornerRadiusBottomLeft"; "flatCornerRadiusTopLeft": "flatCornerRadiusTopLeft"; "flatCornerRadiusTopRight": "flatCornerRadiusTopRight"; "backgroundColor": "backgroundColor"; "disabledBackgroundColor": "disabledBackgroundColor"; "disabledBorderColor": "disabledBorderColor"; "disabledTextColor": "disabledTextColor"; "disabledElevation": "disabledElevation"; "elevationMode": "elevationMode"; "hoverBackgroundColor": "hoverBackgroundColor"; "borderColor": "borderColor"; "restingElevation": "restingElevation"; "hoverElevation": "hoverElevation"; "focusElevation": "focusElevation"; "textStyle": "textStyle"; "textColor": "textColor"; "hoverTextColor": "hoverTextColor"; "rippleColor": "rippleColor"; "raisedTextColor": "raisedTextColor"; "raisedHoverTextColor": "raisedHoverTextColor"; "raisedFocusBackgroundColor": "raisedFocusBackgroundColor"; "raisedFocusTextColor": "raisedFocusTextColor"; "focusBackgroundColor": "focusBackgroundColor"; "focusTextColor": "focusTextColor"; "borderWidth": "borderWidth"; "cornerRadiusBottomRight": "cornerRadiusBottomRight"; "cornerRadiusBottomLeft": "cornerRadiusBottomLeft"; "cornerRadiusTopLeft": "cornerRadiusTopLeft"; "cornerRadiusTopRight": "cornerRadiusTopRight"; "outlinedBackgroundColor": "outlinedBackgroundColor"; "outlinedDisabledBackgroundColor": "outlinedDisabledBackgroundColor"; "outlinedDisabledBorderColor": "outlinedDisabledBorderColor"; "outlinedDisabledTextColor": "outlinedDisabledTextColor"; "outlinedDisabledElevation": "outlinedDisabledElevation"; "outlinedHoverBackgroundColor": "outlinedHoverBackgroundColor"; "outlinedBorderColor": "outlinedBorderColor"; "outlinedRestingElevation": "outlinedRestingElevation"; "outlinedHoverElevation": "outlinedHoverElevation"; "outlinedFocusElevation": "outlinedFocusElevation"; "outlinedBorderWidth": "outlinedBorderWidth"; "outlinedCornerRadiusBottomRight": "outlinedCornerRadiusBottomRight"; "outlinedCornerRadiusBottomLeft": "outlinedCornerRadiusBottomLeft"; "outlinedCornerRadiusTopLeft": "outlinedCornerRadiusTopLeft"; "outlinedCornerRadiusTopRight": "outlinedCornerRadiusTopRight"; "outlinedRippleColor": "outlinedRippleColor"; "outlinedTextColor": "outlinedTextColor"; "outlinedHoverTextColor": "outlinedHoverTextColor"; "outlinedFocusBackgroundColor": "outlinedFocusBackgroundColor"; "outlinedFocusTextColor": "outlinedFocusTextColor"; "fabBackgroundColor": "fabBackgroundColor"; "fabDisabledBackgroundColor": "fabDisabledBackgroundColor"; "fabDisabledBorderColor": "fabDisabledBorderColor"; "fabDisabledTextColor": "fabDisabledTextColor"; "fabDisabledElevation": "fabDisabledElevation"; "fabHoverBackgroundColor": "fabHoverBackgroundColor"; "fabBorderColor": "fabBorderColor"; "fabRestingElevation": "fabRestingElevation"; "fabHoverElevation": "fabHoverElevation"; "fabFocusElevation": "fabFocusElevation"; "fabBorderWidth": "fabBorderWidth"; "fabCornerRadiusBottomRight": "fabCornerRadiusBottomRight"; "fabCornerRadiusBottomLeft": "fabCornerRadiusBottomLeft"; "fabCornerRadiusTopLeft": "fabCornerRadiusTopLeft"; "fabCornerRadiusTopRight": "fabCornerRadiusTopRight"; "fabRippleColor": "fabRippleColor"; "fabTextColor": "fabTextColor"; "fabHoverTextColor": "fabHoverTextColor"; "fabFocusBackgroundColor": "fabFocusBackgroundColor"; "fabFocusTextColor": "fabFocusTextColor"; "iconBackgroundColor": "iconBackgroundColor"; "iconDisabledBackgroundColor": "iconDisabledBackgroundColor"; "iconDisabledBorderColor": "iconDisabledBorderColor"; "iconDisabledTextColor": "iconDisabledTextColor"; "iconDisabledElevation": "iconDisabledElevation"; "iconHoverBackgroundColor": "iconHoverBackgroundColor"; "iconBorderColor": "iconBorderColor"; "iconRestingElevation": "iconRestingElevation"; "iconHoverElevation": "iconHoverElevation"; "iconFocusElevation": "iconFocusElevation"; "iconBorderWidth": "iconBorderWidth"; "iconCornerRadiusBottomRight": "iconCornerRadiusBottomRight"; "iconCornerRadiusBottomLeft": "iconCornerRadiusBottomLeft"; "iconCornerRadiusTopLeft": "iconCornerRadiusTopLeft"; "iconCornerRadiusTopRight": "iconCornerRadiusTopRight"; "iconRippleColor": "iconRippleColor"; "iconTextColor": "iconTextColor"; "iconHoverTextColor": "iconHoverTextColor"; "iconFocusBackgroundColor": "iconFocusBackgroundColor"; "iconFocusTextColor": "iconFocusTextColor"; "inputId": "inputId"; "id": "id"; "display": "display"; "flexDirection": "flexDirection"; "flexGrow": "flexGrow"; "alignItems": "alignItems"; "value": "value"; "name": "name"; "tabIndex": "tabindex"; "ariaLabel": "aria-label"; "fillAvailableSpace": "fillAvailableSpace"; "focused": "focused"; "isFocusStyleEnabled": "isFocusStyleEnabled"; "disableRipple": "disableRipple"; "actualDisableRipple": "actualDisableRipple"; "disableHover": "disableHover"; "isHover": "isHover"; "disabled": "disabled"; "disableTransitions": "disableTransitions"; "disablePointer": "disablePointer"; "contentPaddingLeft": "contentPaddingLeft"; "contentPaddingTop": "contentPaddingTop"; "contentPaddingRight": "contentPaddingRight"; "contentPaddingBottom": "contentPaddingBottom"; "horizontalContentAlignment": "horizontalContentAlignment"; "verticalContentAlignment": "verticalContentAlignment"; "clickTunneling": "clickTunneling"; }, { "clicked": "clicked"; "gotFocus": "gotFocus"; "lostFocus": "lostFocus"; }, never, ["*"]>;
}
