import { EventEmitter, ViewContainerRef, Injector, ComponentFactoryResolver, AfterViewInit, Renderer2, ElementRef, NgZone } from '@angular/core';
import { XCalendar } from './XCalendar';
import { IgxSelectedValueChangedEventArgs } from "./igx-selected-value-changed-event-args";
import { ControlDisplayDensity } from "igniteui-angular-core";
import { BaseControlTheme } from "igniteui-angular-core";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
import * as i0 from "@angular/core";
export declare class IgxXCalendarComponent implements AfterViewInit {
    private renderer;
    private _elRef;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    _calendarContainer: ElementRef;
    private _height;
    private _width;
    private _dataSource;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _wrapper;
    private _root;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    private _implementation;
    ngAfterViewInit(): void;
    protected createImplementation(): XCalendar;
    get i(): XCalendar;
    private _calendar;
    /**
 * Gets or Sets the value for the calendar.
*/
    get value(): Date;
    set value(v: Date);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get today(): Date;
    set today(v: Date);
    /**
     * Gets or Sets the property name that contains the MinDate.
    */
    get minDate(): Date;
    set minDate(v: Date);
    /**
     * Gets or Sets the property name that contains the MaxDate.
    */
    get maxDate(): Date;
    set maxDate(v: Date);
    /**
     * Gets or sets the display density to use for the calendar.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    static ngAcceptInputType_density: ControlDisplayDensity | string;
    /**
     * Gets or sets the base built in theme to use for the calendar.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    static ngAcceptInputType_baseTheme: BaseControlTheme | string;
    /**
     * Gets or Sets the selected date background color
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or Sets the selected date background color
    */
    get selectedDateBackgroundColor(): string;
    set selectedDateBackgroundColor(v: string);
    /**
     * Gets or Sets the selected date background color
    */
    get selectedFocusDateBackgroundColor(): string;
    set selectedFocusDateBackgroundColor(v: string);
    /**
     * Gets or Sets the focus date background color
    */
    get focusDateBackgroundColor(): string;
    set focusDateBackgroundColor(v: string);
    /**
     * Gets or Sets the focus date background color
    */
    get hoverBackgroundColor(): string;
    set hoverBackgroundColor(v: string);
    /**
     * Gets or Sets the selected date text color
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or Sets the selected date text color
    */
    get selectedDateTextColor(): string;
    set selectedDateTextColor(v: string);
    /**
     * Gets or Sets the focus date text color
    */
    get focusDateTextColor(): string;
    set focusDateTextColor(v: string);
    /**
     * Gets or Sets the current date text color
    */
    get currentDateTextColor(): string;
    set currentDateTextColor(v: string);
    /**
     * Gets or Sets the current date text color
    */
    get currentDateBorderColor(): string;
    set currentDateBorderColor(v: string);
    /**
     * Gets or sets the ShowTodayButton property to detirmine if the today button is shown
    */
    get showTodayButton(): boolean;
    set showTodayButton(v: boolean);
    static ngAcceptInputType_showTodayButton: boolean | string;
    /**
     * Gets or sets the font to use for the combobox.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the FirstDayOfWeek property to detirmine first day of the week
    */
    get firstDayOfWeek(): DayOfWeek;
    set firstDayOfWeek(v: DayOfWeek);
    static ngAcceptInputType_firstDayOfWeek: DayOfWeek | string;
    /**
     * Gets or sets the FirstWeekOfYear property to detirmine first week of the year
    */
    get firstWeekOfYear(): FirstWeek;
    set firstWeekOfYear(v: FirstWeek);
    static ngAcceptInputType_firstWeekOfYear: FirstWeek | string;
    /**
     * Gets or sets the ShowWeekNumbers property to detirmine if the week numbers are shown
    */
    get showWeekNumbers(): boolean;
    set showWeekNumbers(v: boolean);
    static ngAcceptInputType_showWeekNumbers: boolean | string;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Exports visual information about the current state of the grid.

*/
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _selectedValueChanged;
    /**
     * Called when date is selected.
    */
    get selectedValueChanged(): EventEmitter<{
        sender: any;
        args: IgxSelectedValueChangedEventArgs;
    }>;
    private _valueChange;
    get valueChange(): EventEmitter<Date>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxXCalendarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxXCalendarComponent, "igx-x-calendar", never, { "height": "height"; "width": "width"; "value": "value"; "today": "today"; "minDate": "minDate"; "maxDate": "maxDate"; "density": "density"; "baseTheme": "baseTheme"; "backgroundColor": "backgroundColor"; "selectedDateBackgroundColor": "selectedDateBackgroundColor"; "selectedFocusDateBackgroundColor": "selectedFocusDateBackgroundColor"; "focusDateBackgroundColor": "focusDateBackgroundColor"; "hoverBackgroundColor": "hoverBackgroundColor"; "textColor": "textColor"; "selectedDateTextColor": "selectedDateTextColor"; "focusDateTextColor": "focusDateTextColor"; "currentDateTextColor": "currentDateTextColor"; "currentDateBorderColor": "currentDateBorderColor"; "showTodayButton": "showTodayButton"; "textStyle": "textStyle"; "firstDayOfWeek": "firstDayOfWeek"; "firstWeekOfYear": "firstWeekOfYear"; "showWeekNumbers": "showWeekNumbers"; }, { "selectedValueChanged": "selectedValueChanged"; "valueChange": "valueChange"; }, never, never>;
}
