import { TemplateRef, ViewContainerRef, Injector, ComponentFactoryResolver, AfterViewInit, AfterContentInit, Renderer2, QueryList, NgZone } from '@angular/core';
import { XInputGroup } from "./XInputGroup";
import { IgxXInputGroupItemComponent } from './igx-x-input-group-item-component';
import { IgxXInputGroupInputCollection } from './igx-x-input-group-input-collection';
import { InputGroupDisplayType } from './InputGroupDisplayType';
import { ControlDisplayDensity } from "igniteui-angular-core";
import { BaseControlTheme } from "igniteui-angular-core";
import * as i0 from "@angular/core";
export declare class IgxXInputGroupComponent implements AfterViewInit, AfterContentInit {
    private renderer;
    private _elRef;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    private _wrapper;
    private _portalManager;
    private _root;
    _dynamicContent: ViewContainerRef;
    _childTemplateRef: TemplateRef<any>;
    contentInputs: QueryList<IgxXInputGroupItemComponent>;
    /**
    * The style mappings actually present in the chart. Do not directly modify this array.
    * This array's contents can be modified by causing Angular to reproject the child content.
    * Or adding and removing stye mappings from the manual style mapping collection on the styleMappings property.
    */
    actualInputs: IgxXInputGroupItemComponent[];
    private _inputs;
    private _inputsAdapter;
    /**
     * A collection or manually added axes for the chart.
    */
    get inputs(): IgxXInputGroupInputCollection;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    private _implementation;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    protected createImplementation(): XInputGroup;
    get i(): XInputGroup;
    private _inputGroup;
    /**
 * Gets or sets the display style to use for the button.
*/
    get displayType(): InputGroupDisplayType;
    set displayType(v: InputGroupDisplayType);
    static ngAcceptInputType_displayType: InputGroupDisplayType | string;
    /**
     * Gets or sets the display density to use for the input group.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    static ngAcceptInputType_density: ControlDisplayDensity | string;
    /**
     * Gets the actual display density to use for the input group.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    static ngAcceptInputType_actualDensity: ControlDisplayDensity | string;
    /**
     * Gets or sets the base built in theme to use for the label.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    static ngAcceptInputType_baseTheme: BaseControlTheme | string;
    get inputHasValue(): boolean;
    static ngAcceptInputType_inputHasValue: boolean | string;
    /**
     * Gets the actual item background color.
    */
    get actualBorderColor(): string;
    set actualBorderColor(v: string);
    /**
     * Gets the actual item border color.
    */
    get actualFocusBorderColor(): string;
    set actualFocusBorderColor(v: string);
    /**
     * Gets the actual item border width.
    */
    get actualBorderWidth(): number;
    set actualBorderWidth(v: number);
    static ngAcceptInputType_actualBorderWidth: number | string;
    /**
     * Gets the actual item border width.
    */
    get actualFocusBorderWidth(): number;
    set actualFocusBorderWidth(v: number);
    static ngAcceptInputType_actualFocusBorderWidth: number | string;
    get actualCornerRadiusBottomRight(): number;
    set actualCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_actualCornerRadiusBottomRight: number | string;
    get actualCornerRadiusBottomLeft(): number;
    set actualCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_actualCornerRadiusBottomLeft: number | string;
    get actualCornerRadiusTopLeft(): number;
    set actualCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_actualCornerRadiusTopLeft: number | string;
    get actualCornerRadiusTopRight(): number;
    set actualCornerRadiusTopRight(v: number);
    static ngAcceptInputType_actualCornerRadiusTopRight: number | string;
    ensureActualCornerRadius(): void;
    get actualContentPaddingBottom(): number;
    set actualContentPaddingBottom(v: number);
    static ngAcceptInputType_actualContentPaddingBottom: number | string;
    get actualContentPaddingLeft(): number;
    set actualContentPaddingLeft(v: number);
    static ngAcceptInputType_actualContentPaddingLeft: number | string;
    get actualContentPaddingRight(): number;
    set actualContentPaddingRight(v: number);
    static ngAcceptInputType_actualContentPaddingRight: number | string;
    get actualContentPaddingTop(): number;
    set actualContentPaddingTop(v: number);
    static ngAcceptInputType_actualContentPaddingTop: number | string;
    ensureActualContentPadding(): void;
    /**
     * Gets the actual width to use for the underline element.
    */
    get actualUnderlineWidth(): number;
    set actualUnderlineWidth(v: number);
    static ngAcceptInputType_actualUnderlineWidth: number | string;
    /**
     * Gets the actual width to use for the underline element.
    */
    get actualUnderlineRippleWidth(): number;
    set actualUnderlineRippleWidth(v: number);
    static ngAcceptInputType_actualUnderlineRippleWidth: number | string;
    /**
     * Gets the width to use for the underline element when hovered.
    */
    get actualHoverUnderlineWidth(): number;
    set actualHoverUnderlineWidth(v: number);
    static ngAcceptInputType_actualHoverUnderlineWidth: number | string;
    /**
     * Gets the actual color to use for the underline element.
    */
    get actualUnderlineColor(): string;
    set actualUnderlineColor(v: string);
    /**
     * Gets the actual color to use for the underline ripple element.
    */
    get actualUnderlineRippleColor(): string;
    set actualUnderlineRippleColor(v: string);
    /**
     * Gets the actual color to use for the underline element.
    */
    get actualHoverUnderlineColor(): string;
    set actualHoverUnderlineColor(v: string);
    /**
     * Gets the actual color to use for the underline element when focused.
    */
    get actualFocusUnderlineColor(): string;
    set actualFocusUnderlineColor(v: string);
    /**
     * Gets the actual opacity to use for the underline element.
    */
    get actualUnderlineOpacity(): number;
    set actualUnderlineOpacity(v: number);
    static ngAcceptInputType_actualUnderlineOpacity: number | string;
    /**
     * Gets the actual opacity to use for the underline element when hovered.
    */
    get actualHoverUnderlineOpacity(): number;
    set actualHoverUnderlineOpacity(v: number);
    static ngAcceptInputType_actualHoverUnderlineOpacity: number | string;
    /**
     * Gets the actual opacity to use for the underline element when focused.
    */
    get actualFocusUnderlineOpacity(): number;
    set actualFocusUnderlineOpacity(v: number);
    static ngAcceptInputType_actualFocusUnderlineOpacity: number | string;
    /**
     * Gets the actual opacity to use for the underline ripple element when focused.
    */
    get actualFocusUnderlineRippleOpacity(): number;
    set actualFocusUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_actualFocusUnderlineRippleOpacity: number | string;
    /**
     * Gets the actual opacity to use for the underline ripple element.
    */
    get actualUnderlineRippleOpacity(): number;
    set actualUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_actualUnderlineRippleOpacity: number | string;
    /**
     * Gets the actual opacity to use for the underline ripple element.
    */
    get actualBackgroundColor(): string;
    set actualBackgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group.
    */
    get borderWidth(): number;
    set borderWidth(v: number);
    static ngAcceptInputType_borderWidth: number | string;
    /**
     * Gets or sets the border width to use for the border of the item group when focused.
    */
    get focusBorderWidth(): number;
    set focusBorderWidth(v: number);
    static ngAcceptInputType_focusBorderWidth: number | string;
    /**
     * Gets or sets the color to use the border of the input group.
    */
    get borderColor(): string;
    set borderColor(v: string);
    get cornerRadiusBottomRight(): number;
    set cornerRadiusBottomRight(v: number);
    static ngAcceptInputType_cornerRadiusBottomRight: number | string;
    get cornerRadiusBottomLeft(): number;
    set cornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_cornerRadiusBottomLeft: number | string;
    get cornerRadiusTopLeft(): number;
    set cornerRadiusTopLeft(v: number);
    static ngAcceptInputType_cornerRadiusTopLeft: number | string;
    get cornerRadiusTopRight(): number;
    set cornerRadiusTopRight(v: number);
    static ngAcceptInputType_cornerRadiusTopRight: number | string;
    ensureCornerRadius(): void;
    get contentPaddingBottom(): number;
    set contentPaddingBottom(v: number);
    static ngAcceptInputType_contentPaddingBottom: number | string;
    get contentPaddingLeft(): number;
    set contentPaddingLeft(v: number);
    static ngAcceptInputType_contentPaddingLeft: number | string;
    get contentPaddingRight(): number;
    set contentPaddingRight(v: number);
    static ngAcceptInputType_contentPaddingRight: number | string;
    get contentPaddingTop(): number;
    set contentPaddingTop(v: number);
    static ngAcceptInputType_contentPaddingTop: number | string;
    ensureContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element.
    */
    get underlineWidth(): number;
    set underlineWidth(v: number);
    static ngAcceptInputType_underlineWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element.
    */
    get underlineRippleWidth(): number;
    set underlineRippleWidth(v: number);
    static ngAcceptInputType_underlineRippleWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when hovered.
    */
    get hoverUnderlineWidth(): number;
    set hoverUnderlineWidth(v: number);
    static ngAcceptInputType_hoverUnderlineWidth: number | string;
    /**
     * Gets or sets the color to use for the underline element.
    */
    get underlineColor(): string;
    set underlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element.
    */
    get underlineRippleColor(): string;
    set underlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get hoverUnderlineColor(): string;
    set hoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get focusUnderlineColor(): string;
    set focusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element.
    */
    get underlineOpacity(): number;
    set underlineOpacity(v: number);
    static ngAcceptInputType_underlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element.
    */
    get hoverUnderlineOpacity(): number;
    set hoverUnderlineOpacity(v: number);
    static ngAcceptInputType_hoverUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element.
    */
    get focusUnderlineOpacity(): number;
    set focusUnderlineOpacity(v: number);
    static ngAcceptInputType_focusUnderlineOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused.
    */
    get focusUnderlineRippleOpacity(): number;
    set focusUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_focusUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element.
    */
    get underlineRippleOpacity(): number;
    set underlineRippleOpacity(v: number);
    static ngAcceptInputType_underlineRippleOpacity: number | string;
    /**
     * Gets or sets the background color to use for the input group.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group when using type line.
    */
    get lineTypeBorderWidth(): number;
    set lineTypeBorderWidth(v: number);
    static ngAcceptInputType_lineTypeBorderWidth: number | string;
    /**
     * Gets or sets the border width to use for the border of the item group when focused when type is line.
    */
    get lineTypeFocusBorderWidth(): number;
    set lineTypeFocusBorderWidth(v: number);
    static ngAcceptInputType_lineTypeFocusBorderWidth: number | string;
    /**
     * Gets or sets the focus color to use the border of the input group when type is line.
    */
    get lineTypeFocusBorderColor(): string;
    set lineTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the border of the input group when type is line.
    */
    get lineTypeBorderColor(): string;
    set lineTypeBorderColor(v: string);
    get lineTypeCornerRadiusBottomRight(): number;
    set lineTypeCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_lineTypeCornerRadiusBottomRight: number | string;
    get lineTypeCornerRadiusBottomLeft(): number;
    set lineTypeCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_lineTypeCornerRadiusBottomLeft: number | string;
    get lineTypeCornerRadiusTopLeft(): number;
    set lineTypeCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_lineTypeCornerRadiusTopLeft: number | string;
    get lineTypeCornerRadiusTopRight(): number;
    set lineTypeCornerRadiusTopRight(v: number);
    static ngAcceptInputType_lineTypeCornerRadiusTopRight: number | string;
    ensureLineTypeCornerRadius(): void;
    get lineTypeContentPaddingBottom(): number;
    set lineTypeContentPaddingBottom(v: number);
    static ngAcceptInputType_lineTypeContentPaddingBottom: number | string;
    get lineTypeContentPaddingLeft(): number;
    set lineTypeContentPaddingLeft(v: number);
    static ngAcceptInputType_lineTypeContentPaddingLeft: number | string;
    get lineTypeContentPaddingRight(): number;
    set lineTypeContentPaddingRight(v: number);
    static ngAcceptInputType_lineTypeContentPaddingRight: number | string;
    get lineTypeContentPaddingTop(): number;
    set lineTypeContentPaddingTop(v: number);
    static ngAcceptInputType_lineTypeContentPaddingTop: number | string;
    ensureLineTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is line.
    */
    get lineTypeUnderlineWidth(): number;
    set lineTypeUnderlineWidth(v: number);
    static ngAcceptInputType_lineTypeUnderlineWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when type is line.
    */
    get lineTypeUnderlineRippleWidth(): number;
    set lineTypeUnderlineRippleWidth(v: number);
    static ngAcceptInputType_lineTypeUnderlineRippleWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when hovered when type is line.
    */
    get lineTypeHoverUnderlineWidth(): number;
    set lineTypeHoverUnderlineWidth(v: number);
    static ngAcceptInputType_lineTypeHoverUnderlineWidth: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeUnderlineColor(): string;
    set lineTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is line.
    */
    get lineTypeUnderlineRippleColor(): string;
    set lineTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeHoverUnderlineColor(): string;
    set lineTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeFocusUnderlineColor(): string;
    set lineTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeUnderlineOpacity(): number;
    set lineTypeUnderlineOpacity(v: number);
    static ngAcceptInputType_lineTypeUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeHoverUnderlineOpacity(): number;
    set lineTypeHoverUnderlineOpacity(v: number);
    static ngAcceptInputType_lineTypeHoverUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is line.
    */
    get lineTypeFocusUnderlineOpacity(): number;
    set lineTypeFocusUnderlineOpacity(v: number);
    static ngAcceptInputType_lineTypeFocusUnderlineOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is line.
    */
    get lineTypeFocusUnderlineRippleOpacity(): number;
    set lineTypeFocusUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_lineTypeFocusUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is line.
    */
    get lineTypeUnderlineRippleOpacity(): number;
    set lineTypeUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_lineTypeUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the background color to use for the input group when type is line.
    */
    get lineTypeBackgroundColor(): string;
    set lineTypeBackgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group when using type line.
    */
    get boxTypeBorderWidth(): number;
    set boxTypeBorderWidth(v: number);
    static ngAcceptInputType_boxTypeBorderWidth: number | string;
    /**
     * Gets or sets the border width to use for the border of the item group when focused when type is box.
    */
    get boxTypeFocusBorderWidth(): number;
    set boxTypeFocusBorderWidth(v: number);
    static ngAcceptInputType_boxTypeFocusBorderWidth: number | string;
    /**
     * Gets or sets the focus color to use the border of the input group when type is box.
    */
    get boxTypeFocusBorderColor(): string;
    set boxTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the border of the input group when type is box.
    */
    get boxTypeBorderColor(): string;
    set boxTypeBorderColor(v: string);
    get boxTypeCornerRadiusBottomRight(): number;
    set boxTypeCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_boxTypeCornerRadiusBottomRight: number | string;
    get boxTypeCornerRadiusBottomLeft(): number;
    set boxTypeCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_boxTypeCornerRadiusBottomLeft: number | string;
    get boxTypeCornerRadiusTopLeft(): number;
    set boxTypeCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_boxTypeCornerRadiusTopLeft: number | string;
    get boxTypeCornerRadiusTopRight(): number;
    set boxTypeCornerRadiusTopRight(v: number);
    static ngAcceptInputType_boxTypeCornerRadiusTopRight: number | string;
    ensureBoxTypeCornerRadius(): void;
    get boxTypeContentPaddingBottom(): number;
    set boxTypeContentPaddingBottom(v: number);
    static ngAcceptInputType_boxTypeContentPaddingBottom: number | string;
    get boxTypeContentPaddingLeft(): number;
    set boxTypeContentPaddingLeft(v: number);
    static ngAcceptInputType_boxTypeContentPaddingLeft: number | string;
    get boxTypeContentPaddingRight(): number;
    set boxTypeContentPaddingRight(v: number);
    static ngAcceptInputType_boxTypeContentPaddingRight: number | string;
    get boxTypeContentPaddingTop(): number;
    set boxTypeContentPaddingTop(v: number);
    static ngAcceptInputType_boxTypeContentPaddingTop: number | string;
    ensureBoxTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is box.
    */
    get boxTypeUnderlineWidth(): number;
    set boxTypeUnderlineWidth(v: number);
    static ngAcceptInputType_boxTypeUnderlineWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when type is box.
    */
    get boxTypeUnderlineRippleWidth(): number;
    set boxTypeUnderlineRippleWidth(v: number);
    static ngAcceptInputType_boxTypeUnderlineRippleWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when hovered when type is box.
    */
    get boxTypeHoverUnderlineWidth(): number;
    set boxTypeHoverUnderlineWidth(v: number);
    static ngAcceptInputType_boxTypeHoverUnderlineWidth: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeUnderlineColor(): string;
    set boxTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is box.
    */
    get boxTypeUnderlineRippleColor(): string;
    set boxTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeHoverUnderlineColor(): string;
    set boxTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeFocusUnderlineColor(): string;
    set boxTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeUnderlineOpacity(): number;
    set boxTypeUnderlineOpacity(v: number);
    static ngAcceptInputType_boxTypeUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeHoverUnderlineOpacity(): number;
    set boxTypeHoverUnderlineOpacity(v: number);
    static ngAcceptInputType_boxTypeHoverUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is box.
    */
    get boxTypeFocusUnderlineOpacity(): number;
    set boxTypeFocusUnderlineOpacity(v: number);
    static ngAcceptInputType_boxTypeFocusUnderlineOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is box.
    */
    get boxTypeFocusUnderlineRippleOpacity(): number;
    set boxTypeFocusUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_boxTypeFocusUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is box.
    */
    get boxTypeUnderlineRippleOpacity(): number;
    set boxTypeUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_boxTypeUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the background color to use for the input group when type is box.
    */
    get boxTypeBackgroundColor(): string;
    set boxTypeBackgroundColor(v: string);
    /**
     * Gets or sets the border width to use for the border of the item group when using type line.
    */
    get borderTypeBorderWidth(): number;
    set borderTypeBorderWidth(v: number);
    static ngAcceptInputType_borderTypeBorderWidth: number | string;
    /**
     * Gets or sets the border width to use for the border of the item group when focused when type is border.
    */
    get borderTypeFocusBorderWidth(): number;
    set borderTypeFocusBorderWidth(v: number);
    static ngAcceptInputType_borderTypeFocusBorderWidth: number | string;
    /**
     * Gets or sets the focus color to use the border of the input group when type is border.
    */
    get borderTypeFocusBorderColor(): string;
    set borderTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the border of the input group when type is border.
    */
    get borderTypeBorderColor(): string;
    set borderTypeBorderColor(v: string);
    get borderTypeCornerRadiusBottomRight(): number;
    set borderTypeCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_borderTypeCornerRadiusBottomRight: number | string;
    get borderTypeCornerRadiusBottomLeft(): number;
    set borderTypeCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_borderTypeCornerRadiusBottomLeft: number | string;
    get borderTypeCornerRadiusTopLeft(): number;
    set borderTypeCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_borderTypeCornerRadiusTopLeft: number | string;
    get borderTypeCornerRadiusTopRight(): number;
    set borderTypeCornerRadiusTopRight(v: number);
    static ngAcceptInputType_borderTypeCornerRadiusTopRight: number | string;
    ensureBorderTypeCornerRadius(): void;
    get borderTypeContentPaddingBottom(): number;
    set borderTypeContentPaddingBottom(v: number);
    static ngAcceptInputType_borderTypeContentPaddingBottom: number | string;
    get borderTypeContentPaddingLeft(): number;
    set borderTypeContentPaddingLeft(v: number);
    static ngAcceptInputType_borderTypeContentPaddingLeft: number | string;
    get borderTypeContentPaddingRight(): number;
    set borderTypeContentPaddingRight(v: number);
    static ngAcceptInputType_borderTypeContentPaddingRight: number | string;
    get borderTypeContentPaddingTop(): number;
    set borderTypeContentPaddingTop(v: number);
    static ngAcceptInputType_borderTypeContentPaddingTop: number | string;
    ensureBorderTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is border.
    */
    get borderTypeUnderlineWidth(): number;
    set borderTypeUnderlineWidth(v: number);
    static ngAcceptInputType_borderTypeUnderlineWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when type is border.
    */
    get borderTypeUnderlineRippleWidth(): number;
    set borderTypeUnderlineRippleWidth(v: number);
    static ngAcceptInputType_borderTypeUnderlineRippleWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when hovered when type is border.
    */
    get borderTypeHoverUnderlineWidth(): number;
    set borderTypeHoverUnderlineWidth(v: number);
    static ngAcceptInputType_borderTypeHoverUnderlineWidth: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeUnderlineColor(): string;
    set borderTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is border.
    */
    get borderTypeUnderlineRippleColor(): string;
    set borderTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeHoverUnderlineColor(): string;
    set borderTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeFocusUnderlineColor(): string;
    set borderTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeUnderlineOpacity(): number;
    set borderTypeUnderlineOpacity(v: number);
    static ngAcceptInputType_borderTypeUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeHoverUnderlineOpacity(): number;
    set borderTypeHoverUnderlineOpacity(v: number);
    static ngAcceptInputType_borderTypeHoverUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is border.
    */
    get borderTypeFocusUnderlineOpacity(): number;
    set borderTypeFocusUnderlineOpacity(v: number);
    static ngAcceptInputType_borderTypeFocusUnderlineOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is border.
    */
    get borderTypeFocusUnderlineRippleOpacity(): number;
    set borderTypeFocusUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_borderTypeFocusUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is border.
    */
    get borderTypeUnderlineRippleOpacity(): number;
    set borderTypeUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_borderTypeUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the background color to use for the input group when type is border.
    */
    get borderTypeBackgroundColor(): string;
    set borderTypeBackgroundColor(v: string);
    /**
     * Gets or sets the search width to use for the border of the item group when using type line.
    */
    get searchTypeBorderWidth(): number;
    set searchTypeBorderWidth(v: number);
    static ngAcceptInputType_searchTypeBorderWidth: number | string;
    /**
     * Gets or sets the search width to use for the border of the item group when focused when type is search.
    */
    get searchTypeFocusBorderWidth(): number;
    set searchTypeFocusBorderWidth(v: number);
    static ngAcceptInputType_searchTypeFocusBorderWidth: number | string;
    /**
     * Gets or sets the focus color to use the search of the input group when type is search.
    */
    get searchTypeFocusBorderColor(): string;
    set searchTypeFocusBorderColor(v: string);
    /**
     * Gets or sets the color to use the search of the input group when type is search.
    */
    get searchTypeBorderColor(): string;
    set searchTypeBorderColor(v: string);
    get searchTypeCornerRadiusBottomRight(): number;
    set searchTypeCornerRadiusBottomRight(v: number);
    static ngAcceptInputType_searchTypeCornerRadiusBottomRight: number | string;
    get searchTypeCornerRadiusBottomLeft(): number;
    set searchTypeCornerRadiusBottomLeft(v: number);
    static ngAcceptInputType_searchTypeCornerRadiusBottomLeft: number | string;
    get searchTypeCornerRadiusTopLeft(): number;
    set searchTypeCornerRadiusTopLeft(v: number);
    static ngAcceptInputType_searchTypeCornerRadiusTopLeft: number | string;
    get searchTypeCornerRadiusTopRight(): number;
    set searchTypeCornerRadiusTopRight(v: number);
    static ngAcceptInputType_searchTypeCornerRadiusTopRight: number | string;
    ensureSearchTypeCornerRadius(): void;
    get searchTypeContentPaddingBottom(): number;
    set searchTypeContentPaddingBottom(v: number);
    static ngAcceptInputType_searchTypeContentPaddingBottom: number | string;
    get searchTypeContentPaddingLeft(): number;
    set searchTypeContentPaddingLeft(v: number);
    static ngAcceptInputType_searchTypeContentPaddingLeft: number | string;
    get searchTypeContentPaddingRight(): number;
    set searchTypeContentPaddingRight(v: number);
    static ngAcceptInputType_searchTypeContentPaddingRight: number | string;
    get searchTypeContentPaddingTop(): number;
    set searchTypeContentPaddingTop(v: number);
    static ngAcceptInputType_searchTypeContentPaddingTop: number | string;
    ensureSearchTypeContentPadding(): void;
    /**
     * Gets or sets the width to use for the underline element when type is search.
    */
    get searchTypeUnderlineWidth(): number;
    set searchTypeUnderlineWidth(v: number);
    static ngAcceptInputType_searchTypeUnderlineWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when type is search.
    */
    get searchTypeUnderlineRippleWidth(): number;
    set searchTypeUnderlineRippleWidth(v: number);
    static ngAcceptInputType_searchTypeUnderlineRippleWidth: number | string;
    /**
     * Gets or sets the width to use for the underline element when hovered when type is search.
    */
    get searchTypeHoverUnderlineWidth(): number;
    set searchTypeHoverUnderlineWidth(v: number);
    static ngAcceptInputType_searchTypeHoverUnderlineWidth: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeUnderlineColor(): string;
    set searchTypeUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline ripple element when type is search.
    */
    get searchTypeUnderlineRippleColor(): string;
    set searchTypeUnderlineRippleColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeHoverUnderlineColor(): string;
    set searchTypeHoverUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeFocusUnderlineColor(): string;
    set searchTypeFocusUnderlineColor(v: string);
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeUnderlineOpacity(): number;
    set searchTypeUnderlineOpacity(v: number);
    static ngAcceptInputType_searchTypeUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeHoverUnderlineOpacity(): number;
    set searchTypeHoverUnderlineOpacity(v: number);
    static ngAcceptInputType_searchTypeHoverUnderlineOpacity: number | string;
    /**
     * Gets or sets the color to use for the underline element when type is search.
    */
    get searchTypeFocusUnderlineOpacity(): number;
    set searchTypeFocusUnderlineOpacity(v: number);
    static ngAcceptInputType_searchTypeFocusUnderlineOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when focused when type is search.
    */
    get searchTypeFocusUnderlineRippleOpacity(): number;
    set searchTypeFocusUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_searchTypeFocusUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the opacity to use for the underline ripple element when type is search.
    */
    get searchTypeUnderlineRippleOpacity(): number;
    set searchTypeUnderlineRippleOpacity(v: number);
    static ngAcceptInputType_searchTypeUnderlineRippleOpacity: number | string;
    /**
     * Gets or sets the background color to use for the input group when type is search.
    */
    get searchTypeBackgroundColor(): string;
    set searchTypeBackgroundColor(v: string);
    /**
     * Gets or sets whether the input group is expanded or not.
    */
    get isExpanded(): boolean;
    set isExpanded(v: boolean);
    static ngAcceptInputType_isExpanded: boolean | string;
    /**
     * Gets or sets whether the input group is hovered or not.
    */
    get isHovered(): boolean;
    set isHovered(v: boolean);
    static ngAcceptInputType_isHovered: boolean | string;
    /**
     * Gets or sets whether the input group is hovered or not.
    */
    get isFocused(): boolean;
    set isFocused(v: boolean);
    static ngAcceptInputType_isFocused: boolean | string;
    /**
     * Gets or sets whether the input group is expanded or not.
    */
    get actualIsExpanded(): boolean;
    set actualIsExpanded(v: boolean);
    static ngAcceptInputType_actualIsExpanded: boolean | string;
    /**
     * Gets or sets the color to use the hovered background of the inputs in the group.
    */
    get focusBorderColor(): string;
    set focusBorderColor(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    static ngAcceptInputType_disabled: boolean | string;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxXInputGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxXInputGroupComponent, "igx-x-input-group", never, { "displayType": "displayType"; "density": "density"; "actualDensity": "actualDensity"; "baseTheme": "baseTheme"; "actualBorderColor": "actualBorderColor"; "actualFocusBorderColor": "actualFocusBorderColor"; "actualBorderWidth": "actualBorderWidth"; "actualFocusBorderWidth": "actualFocusBorderWidth"; "actualCornerRadiusBottomRight": "actualCornerRadiusBottomRight"; "actualCornerRadiusBottomLeft": "actualCornerRadiusBottomLeft"; "actualCornerRadiusTopLeft": "actualCornerRadiusTopLeft"; "actualCornerRadiusTopRight": "actualCornerRadiusTopRight"; "actualContentPaddingBottom": "actualContentPaddingBottom"; "actualContentPaddingLeft": "actualContentPaddingLeft"; "actualContentPaddingRight": "actualContentPaddingRight"; "actualContentPaddingTop": "actualContentPaddingTop"; "actualUnderlineWidth": "actualUnderlineWidth"; "actualUnderlineRippleWidth": "actualUnderlineRippleWidth"; "actualHoverUnderlineWidth": "actualHoverUnderlineWidth"; "actualUnderlineColor": "actualUnderlineColor"; "actualUnderlineRippleColor": "actualUnderlineRippleColor"; "actualHoverUnderlineColor": "actualHoverUnderlineColor"; "actualFocusUnderlineColor": "actualFocusUnderlineColor"; "actualUnderlineOpacity": "actualUnderlineOpacity"; "actualHoverUnderlineOpacity": "actualHoverUnderlineOpacity"; "actualFocusUnderlineOpacity": "actualFocusUnderlineOpacity"; "actualFocusUnderlineRippleOpacity": "actualFocusUnderlineRippleOpacity"; "actualUnderlineRippleOpacity": "actualUnderlineRippleOpacity"; "actualBackgroundColor": "actualBackgroundColor"; "borderWidth": "borderWidth"; "focusBorderWidth": "focusBorderWidth"; "borderColor": "borderColor"; "cornerRadiusBottomRight": "cornerRadiusBottomRight"; "cornerRadiusBottomLeft": "cornerRadiusBottomLeft"; "cornerRadiusTopLeft": "cornerRadiusTopLeft"; "cornerRadiusTopRight": "cornerRadiusTopRight"; "contentPaddingBottom": "contentPaddingBottom"; "contentPaddingLeft": "contentPaddingLeft"; "contentPaddingRight": "contentPaddingRight"; "contentPaddingTop": "contentPaddingTop"; "underlineWidth": "underlineWidth"; "underlineRippleWidth": "underlineRippleWidth"; "hoverUnderlineWidth": "hoverUnderlineWidth"; "underlineColor": "underlineColor"; "underlineRippleColor": "underlineRippleColor"; "hoverUnderlineColor": "hoverUnderlineColor"; "focusUnderlineColor": "focusUnderlineColor"; "underlineOpacity": "underlineOpacity"; "hoverUnderlineOpacity": "hoverUnderlineOpacity"; "focusUnderlineOpacity": "focusUnderlineOpacity"; "focusUnderlineRippleOpacity": "focusUnderlineRippleOpacity"; "underlineRippleOpacity": "underlineRippleOpacity"; "backgroundColor": "backgroundColor"; "lineTypeBorderWidth": "lineTypeBorderWidth"; "lineTypeFocusBorderWidth": "lineTypeFocusBorderWidth"; "lineTypeFocusBorderColor": "lineTypeFocusBorderColor"; "lineTypeBorderColor": "lineTypeBorderColor"; "lineTypeCornerRadiusBottomRight": "lineTypeCornerRadiusBottomRight"; "lineTypeCornerRadiusBottomLeft": "lineTypeCornerRadiusBottomLeft"; "lineTypeCornerRadiusTopLeft": "lineTypeCornerRadiusTopLeft"; "lineTypeCornerRadiusTopRight": "lineTypeCornerRadiusTopRight"; "lineTypeContentPaddingBottom": "lineTypeContentPaddingBottom"; "lineTypeContentPaddingLeft": "lineTypeContentPaddingLeft"; "lineTypeContentPaddingRight": "lineTypeContentPaddingRight"; "lineTypeContentPaddingTop": "lineTypeContentPaddingTop"; "lineTypeUnderlineWidth": "lineTypeUnderlineWidth"; "lineTypeUnderlineRippleWidth": "lineTypeUnderlineRippleWidth"; "lineTypeHoverUnderlineWidth": "lineTypeHoverUnderlineWidth"; "lineTypeUnderlineColor": "lineTypeUnderlineColor"; "lineTypeUnderlineRippleColor": "lineTypeUnderlineRippleColor"; "lineTypeHoverUnderlineColor": "lineTypeHoverUnderlineColor"; "lineTypeFocusUnderlineColor": "lineTypeFocusUnderlineColor"; "lineTypeUnderlineOpacity": "lineTypeUnderlineOpacity"; "lineTypeHoverUnderlineOpacity": "lineTypeHoverUnderlineOpacity"; "lineTypeFocusUnderlineOpacity": "lineTypeFocusUnderlineOpacity"; "lineTypeFocusUnderlineRippleOpacity": "lineTypeFocusUnderlineRippleOpacity"; "lineTypeUnderlineRippleOpacity": "lineTypeUnderlineRippleOpacity"; "lineTypeBackgroundColor": "lineTypeBackgroundColor"; "boxTypeBorderWidth": "boxTypeBorderWidth"; "boxTypeFocusBorderWidth": "boxTypeFocusBorderWidth"; "boxTypeFocusBorderColor": "boxTypeFocusBorderColor"; "boxTypeBorderColor": "boxTypeBorderColor"; "boxTypeCornerRadiusBottomRight": "boxTypeCornerRadiusBottomRight"; "boxTypeCornerRadiusBottomLeft": "boxTypeCornerRadiusBottomLeft"; "boxTypeCornerRadiusTopLeft": "boxTypeCornerRadiusTopLeft"; "boxTypeCornerRadiusTopRight": "boxTypeCornerRadiusTopRight"; "boxTypeContentPaddingBottom": "boxTypeContentPaddingBottom"; "boxTypeContentPaddingLeft": "boxTypeContentPaddingLeft"; "boxTypeContentPaddingRight": "boxTypeContentPaddingRight"; "boxTypeContentPaddingTop": "boxTypeContentPaddingTop"; "boxTypeUnderlineWidth": "boxTypeUnderlineWidth"; "boxTypeUnderlineRippleWidth": "boxTypeUnderlineRippleWidth"; "boxTypeHoverUnderlineWidth": "boxTypeHoverUnderlineWidth"; "boxTypeUnderlineColor": "boxTypeUnderlineColor"; "boxTypeUnderlineRippleColor": "boxTypeUnderlineRippleColor"; "boxTypeHoverUnderlineColor": "boxTypeHoverUnderlineColor"; "boxTypeFocusUnderlineColor": "boxTypeFocusUnderlineColor"; "boxTypeUnderlineOpacity": "boxTypeUnderlineOpacity"; "boxTypeHoverUnderlineOpacity": "boxTypeHoverUnderlineOpacity"; "boxTypeFocusUnderlineOpacity": "boxTypeFocusUnderlineOpacity"; "boxTypeFocusUnderlineRippleOpacity": "boxTypeFocusUnderlineRippleOpacity"; "boxTypeUnderlineRippleOpacity": "boxTypeUnderlineRippleOpacity"; "boxTypeBackgroundColor": "boxTypeBackgroundColor"; "borderTypeBorderWidth": "borderTypeBorderWidth"; "borderTypeFocusBorderWidth": "borderTypeFocusBorderWidth"; "borderTypeFocusBorderColor": "borderTypeFocusBorderColor"; "borderTypeBorderColor": "borderTypeBorderColor"; "borderTypeCornerRadiusBottomRight": "borderTypeCornerRadiusBottomRight"; "borderTypeCornerRadiusBottomLeft": "borderTypeCornerRadiusBottomLeft"; "borderTypeCornerRadiusTopLeft": "borderTypeCornerRadiusTopLeft"; "borderTypeCornerRadiusTopRight": "borderTypeCornerRadiusTopRight"; "borderTypeContentPaddingBottom": "borderTypeContentPaddingBottom"; "borderTypeContentPaddingLeft": "borderTypeContentPaddingLeft"; "borderTypeContentPaddingRight": "borderTypeContentPaddingRight"; "borderTypeContentPaddingTop": "borderTypeContentPaddingTop"; "borderTypeUnderlineWidth": "borderTypeUnderlineWidth"; "borderTypeUnderlineRippleWidth": "borderTypeUnderlineRippleWidth"; "borderTypeHoverUnderlineWidth": "borderTypeHoverUnderlineWidth"; "borderTypeUnderlineColor": "borderTypeUnderlineColor"; "borderTypeUnderlineRippleColor": "borderTypeUnderlineRippleColor"; "borderTypeHoverUnderlineColor": "borderTypeHoverUnderlineColor"; "borderTypeFocusUnderlineColor": "borderTypeFocusUnderlineColor"; "borderTypeUnderlineOpacity": "borderTypeUnderlineOpacity"; "borderTypeHoverUnderlineOpacity": "borderTypeHoverUnderlineOpacity"; "borderTypeFocusUnderlineOpacity": "borderTypeFocusUnderlineOpacity"; "borderTypeFocusUnderlineRippleOpacity": "borderTypeFocusUnderlineRippleOpacity"; "borderTypeUnderlineRippleOpacity": "borderTypeUnderlineRippleOpacity"; "borderTypeBackgroundColor": "borderTypeBackgroundColor"; "searchTypeBorderWidth": "searchTypeBorderWidth"; "searchTypeFocusBorderWidth": "searchTypeFocusBorderWidth"; "searchTypeFocusBorderColor": "searchTypeFocusBorderColor"; "searchTypeBorderColor": "searchTypeBorderColor"; "searchTypeCornerRadiusBottomRight": "searchTypeCornerRadiusBottomRight"; "searchTypeCornerRadiusBottomLeft": "searchTypeCornerRadiusBottomLeft"; "searchTypeCornerRadiusTopLeft": "searchTypeCornerRadiusTopLeft"; "searchTypeCornerRadiusTopRight": "searchTypeCornerRadiusTopRight"; "searchTypeContentPaddingBottom": "searchTypeContentPaddingBottom"; "searchTypeContentPaddingLeft": "searchTypeContentPaddingLeft"; "searchTypeContentPaddingRight": "searchTypeContentPaddingRight"; "searchTypeContentPaddingTop": "searchTypeContentPaddingTop"; "searchTypeUnderlineWidth": "searchTypeUnderlineWidth"; "searchTypeUnderlineRippleWidth": "searchTypeUnderlineRippleWidth"; "searchTypeHoverUnderlineWidth": "searchTypeHoverUnderlineWidth"; "searchTypeUnderlineColor": "searchTypeUnderlineColor"; "searchTypeUnderlineRippleColor": "searchTypeUnderlineRippleColor"; "searchTypeHoverUnderlineColor": "searchTypeHoverUnderlineColor"; "searchTypeFocusUnderlineColor": "searchTypeFocusUnderlineColor"; "searchTypeUnderlineOpacity": "searchTypeUnderlineOpacity"; "searchTypeHoverUnderlineOpacity": "searchTypeHoverUnderlineOpacity"; "searchTypeFocusUnderlineOpacity": "searchTypeFocusUnderlineOpacity"; "searchTypeFocusUnderlineRippleOpacity": "searchTypeFocusUnderlineRippleOpacity"; "searchTypeUnderlineRippleOpacity": "searchTypeUnderlineRippleOpacity"; "searchTypeBackgroundColor": "searchTypeBackgroundColor"; "isExpanded": "isExpanded"; "isHovered": "isHovered"; "isFocused": "isFocused"; "actualIsExpanded": "actualIsExpanded"; "focusBorderColor": "focusBorderColor"; "id": "id"; "disabled": "disabled"; }, {}, ["contentInputs"], ["*"]>;
}
