import { TemplateRef, ViewContainerRef, Injector, ComponentFactoryResolver, AfterViewInit, Renderer2, NgZone } from '@angular/core';
import { XLabel } from "./XLabel";
import { IgxXInputGroupItemComponent } from './igx-x-input-group-item-component';
import { ControlDisplayDensity } from "igniteui-angular-core";
import { BaseControlTheme } from "igniteui-angular-core";
import * as i0 from "@angular/core";
export declare class IgxXLabelComponent extends IgxXInputGroupItemComponent implements AfterViewInit {
    private renderer;
    private _elRef;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    private _wrapper;
    private _portalManager;
    private _root;
    _dynamicContent: ViewContainerRef;
    _childTemplateRef: TemplateRef<any>;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    protected createImplementation(): XLabel;
    private _label;
    /**
                             * @hidden
                             */
    get i(): XLabel;
    /**
 * Gets or sets the base built in theme to use for the label.
*/
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    static ngAcceptInputType_baseTheme: BaseControlTheme | string;
    /**
     * Gets or sets the display density to use for the label.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    static ngAcceptInputType_density: ControlDisplayDensity | string;
    /**
     * Gets the actual display density to use for the label.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    static ngAcceptInputType_actualDensity: ControlDisplayDensity | string;
    /**
     * Gets the actual color to use for the text color.
    */
    get actualTextColor(): string;
    set actualTextColor(v: string);
    /**
     * Gets the actual color to use for the text color.
    */
    get actualHighlightTextColor(): string;
    set actualHighlightTextColor(v: string);
    /**
     * Gets the actual color to use for the text color when highlighted and hovered.
    */
    get actualHoverHighlightTextColor(): string;
    set actualHoverHighlightTextColor(v: string);
    /**
     * Gets the actual hover color to use for the text.
    */
    get actualHoverTextColor(): string;
    set actualHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get highlightTextColor(): string;
    set highlightTextColor(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get hoverHighlightTextColor(): string;
    set hoverHighlightTextColor(v: string);
    /**
     * Gets or sets the use for the button.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button regardless of type.
    */
    get hoverTextColor(): string;
    set hoverTextColor(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get display(): string;
    set display(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get flexDirection(): string;
    set flexDirection(v: string);
    /**
     * Gets or sets the flex-grow setting for the button.
    */
    get flexGrow(): string;
    set flexGrow(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get alignItems(): string;
    set alignItems(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get alignSelf(): string;
    set alignSelf(v: string);
    /**
     * Gets or sets TabIndex to use for the checkbox.
    */
    get tabIndex(): number;
    set tabIndex(v: number);
    static ngAcceptInputType_tabIndex: number | string;
    /**
     * Gets or sets the for attribute to use for the label.
    */
    get for(): string;
    set for(v: string);
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    get ariaLabel(): string;
    set ariaLabel(v: string);
    /**
     * Gets or sets the text for the label.
    */
    get text(): string;
    set text(v: string);
    /**
     * Gets or sets whether the label is hovered.
    */
    get isHover(): boolean;
    set isHover(v: boolean);
    static ngAcceptInputType_isHover: boolean | string;
    /**
     * Gets or sets the value for the label.
    */
    get value(): boolean;
    set value(v: boolean);
    static ngAcceptInputType_value: boolean | string;
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    static ngAcceptInputType_disabled: boolean | string;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxXLabelComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxXLabelComponent, "igx-x-label", never, { "baseTheme": "baseTheme"; "density": "density"; "actualDensity": "actualDensity"; "actualTextColor": "actualTextColor"; "actualHighlightTextColor": "actualHighlightTextColor"; "actualHoverHighlightTextColor": "actualHoverHighlightTextColor"; "actualHoverTextColor": "actualHoverTextColor"; "textColor": "textColor"; "highlightTextColor": "highlightTextColor"; "hoverHighlightTextColor": "hoverHighlightTextColor"; "textStyle": "textStyle"; "hoverTextColor": "hoverTextColor"; "id": "id"; "display": "display"; "flexDirection": "flexDirection"; "flexGrow": "flexGrow"; "alignItems": "alignItems"; "alignSelf": "alignSelf"; "tabIndex": "tabindex"; "for": "for"; "ariaLabel": "aria-label"; "text": "text"; "isHover": "isHover"; "value": "value"; "disabled": "disabled"; }, {}, never, ["*"]>;
}
