import { ViewContainerRef, Injector, ComponentFactoryResolver, AfterContentInit, Renderer2, NgZone } from '@angular/core';
import { XRipple } from "./XRipple";
import * as i0 from "@angular/core";
export declare class IgxXRippleComponent implements AfterContentInit {
    private renderer;
    private _elRef;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _top;
    private _left;
    set top(value: string);
    get top(): string;
    set left(value: string);
    get left(): string;
    private _position;
    set position(value: string);
    get position(): string;
    private _wrapper;
    private _root;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    private _implementation;
    ngAfterContentInit(): void;
    protected createImplementation(): XRipple;
    get i(): XRipple;
    private _ripple;
    /**
 * Gets or sets the target element to inject ripples into.
*/
    get eventSource(): any;
    set eventSource(v: any);
    /**
     * Gets or sets the color to use for the background when the checkbox is unchecked.
    */
    get rippleColor(): string;
    set rippleColor(v: string);
    /**
     * Gets or sets the color to use for the background when the ripple is hovered.
    */
    get hoverColor(): string;
    set hoverColor(v: string);
    /**
     * Gets or sets the actual color to use for the background when the ripple is hovered.
    */
    get actualHoverColor(): string;
    set actualHoverColor(v: string);
    /**
     * Gets or sets the color to use for the actual background when the checkbox is unchecked.
    */
    get actualRippleColor(): string;
    set actualRippleColor(v: string);
    /**
     * Gets or sets the duration to use for the ripple animation.
    */
    get rippleDuration(): number;
    set rippleDuration(v: number);
    static ngAcceptInputType_rippleDuration: number | string;
    /**
     * Gets or sets if the ripple is disabled.
    */
    get isDisabled(): boolean;
    set isDisabled(v: boolean);
    static ngAcceptInputType_isDisabled: boolean | string;
    /**
     * Gets or sets if the ripple is centered.
    */
    get isCentered(): boolean;
    set isCentered(v: boolean);
    static ngAcceptInputType_isCentered: boolean | string;
    /**
     * Gets or sets if the ripple is centered.
    */
    get isHoverEnabled(): boolean;
    set isHoverEnabled(v: boolean);
    static ngAcceptInputType_isHoverEnabled: boolean | string;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<IgxXRippleComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<IgxXRippleComponent, "igx-x-ripple", never, { "height": "height"; "width": "width"; "top": "top"; "left": "left"; "position": "position"; "eventSource": "eventSource"; "rippleColor": "rippleColor"; "hoverColor": "hoverColor"; "actualHoverColor": "actualHoverColor"; "actualRippleColor": "actualRippleColor"; "rippleDuration": "rippleDuration"; "isDisabled": "isDisabled"; "isCentered": "isCentered"; "isHoverEnabled": "isHoverEnabled"; }, {}, never, never>;
}
